Namespace Microsoft.Naming

    ' この名前空間は CA1704:Namespace に違反しています。
    Namespace Bura
        ' このデリゲートは CA1704:DelegateParameter に違反しています。
        Public Delegate Sub PrintHandler(ByVal foo As String)
    End Namespace

    ' この名前空間は CA1704:NamespaceMoreMeaningfulName に違反しています。
    Namespace N
        ' このデリゲートは CA1704:DelegateParameterMoreMeaningfulName に違反しています。
        Public Delegate Sub WriteHandler(ByVal p As String)
    End Namespace

    ' このクラスは CA1704:TypeMoreMeaningfulName に違反しています。
    ' このクラスは CA1704:TypeTypeParameterMoreMeaningfulName に違反しています。
    Public Class A(Of T1)

        ' このメソッドは CA1704:MemberMoreMeaningfulName に違反しています。
        ' このメソッドは CA1704:MemberParameterMoreMeaningfulName に違反しています。
        ' このメソッドは CA1704:MethodTypeParameterMoreMeaningfulName に違反しています。
        Public Sub M(Of T2)(ByVal p As T2)
            Console.WriteLine(p)
        End Sub

    End Class

    ' このクラスは CA1704:Type に違反しています。
    ' このクラスは CA1704:TypeTypeParameter に違反しています。
    Public Class Foo(Of TGoo)

        ' このメソッドは CA1704:Member に違反しています。
        ' このメソッドは CA1704:MemberParameter に違反しています。
        ' このメソッドは CA1704:MemberTypeParameter に違反しています。
        Public Sub Bura(Of TSei)(ByVal foo As TSei)
            Console.WriteLine(foo)
        End Sub
    End Class

End Namespace
